> For the complete documentation index, see [llms.txt](https://docs.platform9.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.platform9.com/managed-kubernetes/apis/qbert-api/external-cluster.md).

# External Cluster

## GET /v4/{projectId}/externalClusters/discover

> Provides a list of all the external clusters available to be added to management plane

```json
{"openapi":"3.1.1","info":{"title":"Platform9 Managed Kubernetes","version":"4.0.0"},"servers":[{"url":"/qbert"}],"paths":{"/v4/{projectId}/externalClusters/discover":{"get":{"tags":["ExternalCluster"],"summary":"Provides a list of all the external clusters available to be added to management plane","parameters":[{"schema":{"type":"string"},"name":"X-Auth-Token","in":"header","required":true},{"schema":{"type":"string"},"name":"projectId","in":"path","required":true,"description":"UUID of the project the cluster belongs to"}],"responses":{"200":{"description":"OK, List of external clusters."}}}}}}
```

## POST /v4/{projectId}/externalClusters/register

> Registers an external cluster

```json
{"openapi":"3.1.1","info":{"title":"Platform9 Managed Kubernetes","version":"4.0.0"},"servers":[{"url":"/qbert"}],"paths":{"/v4/{projectId}/externalClusters/register":{"post":{"tags":["ExternalCluster"],"summary":"Registers an external cluster","parameters":[{"schema":{"type":"string"},"name":"X-Auth-Token","in":"header","required":true},{"schema":{"type":"string"},"name":"projectId","in":"path","required":true,"description":"UUID of the project the cluster belongs to"}],"responses":{"200":{"description":"OK, if cluster create request was submitted successfully"},"403":{"description":"Unauthorized to perform this operation"},"404":{"description":"Cluster could not be founds"},"409":{"description":"Cluster already registered"}},"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ext_cluster_register_details_for_post"}}},"required":true}}}},"components":{"schemas":{"ext_cluster_register_details_for_post":{"type":"object","properties":{"id":{"type":"string","description":"An unique cluster idenfier"},"provider":{"type":"string","description":"Name of the external K8S cluster provider service"},"cloudProviderID":{"type":"string","description":"UUID of a cloud provider in PF9"},"providerDetails":{"type":"object","description":"A dynamic field to include cloud specific parameters. For example, for EKS, we need the region to be able to register a cluster"}}}}}}
```

## POST /v4/{projectId}/externalClusters/:clusterID/deregister

> Deregister an external cluster

```json
{"openapi":"3.1.1","info":{"title":"Platform9 Managed Kubernetes","version":"4.0.0"},"servers":[{"url":"/qbert"}],"paths":{"/v4/{projectId}/externalClusters/:clusterID/deregister":{"post":{"tags":["ExternalCluster"],"summary":"Deregister an external cluster","parameters":[{"schema":{"type":"string"},"name":"X-Auth-Token","in":"header","required":true},{"schema":{"type":"string"},"name":"projectId","in":"path","required":true,"description":"UUID of the project the cluster belongs to"}],"responses":{"200":{"description":"OK, if cluster create request was submitted successfully"},"403":{"description":"Unauthorized to perform this operation"}}}}}}
```

## GET /v4/{projectId}/externalClusters/:clusterID/deploymentYAML

> Get the deployment YAML for a private external cluster

```json
{"openapi":"3.1.1","info":{"title":"Platform9 Managed Kubernetes","version":"4.0.0"},"servers":[{"url":"/qbert"}],"paths":{"/v4/{projectId}/externalClusters/:clusterID/deploymentYAML":{"get":{"tags":["ExternalCluster"],"summary":"Get the deployment YAML for a private external cluster","parameters":[{"schema":{"type":"string"},"name":"X-Auth-Token","in":"header","required":true},{"schema":{"type":"string"},"name":"projectId","in":"path","required":true,"description":"UUID of the project the cluster belongs to"}],"responses":{"200":{"description":"OK, if cluster create request was submitted successfully"},"403":{"description":"Unauthorized to perform this operation"},"404":{"description":"Cluster or the cluster agent could not be found"}}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.platform9.com/managed-kubernetes/apis/qbert-api/external-cluster.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
